; 
    include \masm32\include\masm32rt.inc
; 

comment * -----------------------------------------------------
                        Build this  template with
                       "CONSOLE ASSEMBLE AND LINK"
        ----------------------------------------------------- *

    .xmm

    ucLen2   PROTO :DWORD
    EduSSE   PROTO :DWORD
    Edu32W2  PROTO :DWORD
    StrLenW  PROTO :DWORD
    Lingo32W PROTO :DWORD

    .code

start:
   
; 

    call main
    inkey
    exit

; 

main proc

    LOCAL hMem  :DWORD
    LOCAL flen  :DWORD
    LOCAL ubuf  :DWORD
    LOCAL usiz  :DWORD

    mov hMem, InputFile("\masm32\include\windows.inc")
    mov flen, ecx
    add ecx, flen
    mov usiz, ecx

    mov ubuf, alloc(usiz)    ; allocate buffer for unicode text

    invoke MultiByteToWideChar,CP_ACP,MB_PRECOMPOSED,hMem,flen,ubuf,usiz

    push esi

    invoke SetPriorityClass,FUNC(GetCurrentProcess),REALTIME_PRIORITY_CLASS

    REPEAT 4

; ------------------------------

    invoke GetTickCount
    push eax

    mov esi, 1000

  @@:
    invoke ucLen,ubuf
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    print str$(eax)," ucLen",13,10

; ------------------------------

    invoke GetTickCount
    push eax

    mov esi, 1000

  @@:
    invoke ucLen2,ubuf
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    print str$(eax)," ucLen2",13,10

; ------------------------------

    invoke GetTickCount
    push eax

    mov esi, 1000

  @@:
    invoke EduSSE,ubuf
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    print str$(eax)," EduSSE",13,10

; ------------------------------

    invoke GetTickCount
    push eax

    mov esi, 1000

  @@:
    invoke Edu32W2,ubuf
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    print str$(eax)," Edu32W2",13,10

; ------------------------------

    invoke GetTickCount
    push eax

    mov esi, 1000

  @@:
    invoke StrLenW,ubuf
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    print str$(eax)," StrLenW",13,10

; ------------------------------

    invoke GetTickCount
    push eax

    mov esi, 1000

  @@:
    invoke Lingo32W,ubuf
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    print str$(eax)," Lingo32W",13,10

; ------------------------------

    ENDM

    invoke SetPriorityClass,FUNC(GetCurrentProcess),NORMAL_PRIORITY_CLASS

    pop esi

    free hMem
    free ubuf

    ret

main endp

; 

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

align 16

ucLen2 proc lpwstr:DWORD

    mov ecx, [esp+4]    ; lpwstr
    xor eax, eax
    sub ecx, 4

  lbl0:
    add ecx, 4
    mov eax, [ecx]
    cmp ax, 0
    je lbl1
    rol eax, 16
    cmp ax, 0
    jne lbl0

    sub ecx, [esp+4]    ; lpwstr
    mov eax, ecx
    shr eax, 1
    add eax, 1
    ret 4

  lbl1:
    sub ecx, [esp+4]    ; lpwstr
    mov eax, ecx
    shr eax, 1
    ret 4

ucLen2 endp

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

; 

OPTION PROLOGUE:NONE          ; turn it off
OPTION EPILOGUE:NONE

align 16

EduSSE proc src:DWORD
    mov eax, [esp+4]
    pxor MM0, MM0

    @@:
    movq MM1, [eax]
    movq MM2, [eax+8]
    add eax, 16
    packsswb MM1, MM2
    pcmpeqb MM1, MM0
    pmovmskb edx, MM1
    test edx, edx
    jz @B
    
    sub eax, [esp+4]
    bsf edx, edx
    shr eax, 1
    lea eax, [eax+edx-8]
    ret 4
EduSSE endp

OPTION PROLOGUE:PROLOGUEDEF   ; turn back on the defaults
OPTION EPILOGUE:EPILOGUEDEF


; 

OPTION PROLOGUE:NONE          ; turn it off
OPTION EPILOGUE:NONE

align 16

Edu32W2 proc src:DWORD
    mov eax, [esp+4]
    @@:
    mov edx, [eax]
    mov ecx, [eax+4]
    test dx, dx
    lea eax, [eax+8]
    jz sub8
    shr edx, 16
    jz sub6
    test cx, cx
    jz sub4
    shr ecx, 16
    jnz @B
    sub eax, 2
    sub eax, [esp+4]
    shr eax, 1
    ret 4
    
    sub4:
    sub eax, 4
    sub eax, [esp+4]
    shr eax, 1
    ret 4
    
    sub6:
    sub eax, 6
    sub eax, [esp+4]
    shr eax, 1
    ret 4
    
    sub8:
    sub eax, 8
    sub eax, [esp+4]
    shr eax, 1
    ret 4
    
Edu32W2 endp

OPTION PROLOGUE:PROLOGUEDEF   ; turn back on the defaults
OPTION EPILOGUE:EPILOGUEDEF

; 

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

align 16

StrLenW proc public p_lpszStr:dword

   mov eax, [esp+4]
   sub eax, 8
@@:
   add eax, 8
   cmp word ptr [eax], 0
   je Add0
   cmp word ptr [eax+2], 0
   je Add1
   cmp word ptr [eax+4], 0
   je Add2
   cmp word ptr [eax+6], 0
   jne @B

   sub eax, [esp+4]
   shr eax, 1
   add eax, 3
   ret 4

Add2:
   sub eax, [esp+4]
   shr eax, 1
   add eax, 2
   ret 4

Add1:
   sub eax, [esp+4]
   shr eax, 1
   add eax, 1
   ret 4

Add0:
   sub eax, [esp+4]
   shr eax, 1
   ret 4

StrLenW endp

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

; 

OPTION PROLOGUE:NONE          ; turn it off
OPTION EPILOGUE:NONE

align 16

Lingo32W                proc  lpst:DWORD
                        mov   eax, [esp+4]
                        mov   edx, 80008000h
                        mov   ecx, [eax]
@@:
                        add   eax, 4
                        add   ecx, 0FEFFFF00h
                        test  edx, ecx
                        mov   ecx, [eax]
                        je    @b

                        test  word ptr [eax-4], 0FFFFh
                        je    C_minus4 
                        test  word ptr [eax-4+2], 0FFFFh
                        je    C_minus2
@@:
                        and   ecx, 07F7F7F7FH
                        add   eax, 4
                        add   ecx, 0FEFFFF00h
                        test  ecx, edx
                        mov   ecx, [eax]
                        je    @b

                        test  word ptr [eax-4], 0FFFFh
                        je    C_minus4 
			test  word ptr [eax-4+2], 0FFFFh
                        jne   @b
C_minus2:
                        sub   eax, [esp+4]
                        add   eax, 2-4
                        shr   eax,1
                        ret   4
C_minus4:
                        sub   eax, [esp+4]
                        add   eax,0-4
                        shr   eax,1
                        ret   4
Lingo32W                endp

OPTION PROLOGUE:PROLOGUEDEF   ; turn back on the defaults
OPTION EPILOGUE:EPILOGUEDEF

; 

end start
